#python

import lx
import sys
import os
import random
from random import choice
import math
from lx import eval, eval1, evalN, out, Monitor
import re

# Snygga till user values

rhmu_keeporiginal = lx.eval('user.value rhmu_keeporiginal ?')	
rhmu_scale = lx.eval('user.value rhmu_scale ?')	



def dialog(title, msg, type):
	result = ''
	eval('dialog.setup %s'   %type)
	eval('dialog.title "%s"' %title)
	eval('dialog.msg "%s"'   %msg)
	try:
		eval('dialog.open')
		result = eval('dialog.result ?')
	except:
		result = eval('dialog.result ?')
	return result

	
try:

	##########################################
	# Nollstll

	# eval("workPlane.reset")
	# eval("tool.set actr.origin on")
	# eval("tool.setAttr axis.origin axis 2")
	
	# sys.exit()
	
	
	item_name = evalN("item.name ?")
	
	if len(item_name) > 1:
		dialog("Analyzed mesh", "Please select only one mesh", "info")
		sys.exit()
	
	item_name = item_name[0]
	out(item_name)
	
	# sys.exit()
	selected_uv = lx.eval1('vertMap.list type:txuv ?')
	
	if selected_uv == '_____n_o_n_e_____':
		dialog("Analyzed mesh", "Please select a UV map", "info")
		sys.exit()
	
	eval("select.vertexMap {%s} txuv replace" %selected_uv)
	
	################################
	# Kolla om polygoner r valda, annars sluta
	eval("select.type polygon")
	selectedkvar = eval('query layerservice poly.N ? selected')
	if selectedkvar < 1:
		dialog("Analyzed mesh", "Please select some polygons", "info")
		sys.exit()

	#################################
	# Om originalpolygoner ska sparas, gr en sak, annars inte
	if not rhmu_keeporiginal:
		eval("select.cut")
		eval("item.delete")
	else:
		eval("select.copy")
	
	#########################################
	# Kopiera de polygoner som ska anvndas till ett eget lager och spara ned dess storlek
	
	eval("layer.new")
	worklayer = eval("query layerservice layers ? selected")
	eval("select.paste")
	eval("select.type polygon")

	eval("item.name {%s_unwrap} mesh" %item_name)
	eval("select.all")
		
	
	#################################################
	# Splitta verts s att de gr att flytta runt utan problem och 
	eval("select.type vertex")
	eval("vert.split")

		
	#################################################
	# Stoppa alla nya verts i en array
	eval("select.all")
	selectedverts = eval("query layerservice verts ? selected")
	
	###################################################
	# Skapa ny morph map 
	eval("vertMap.new rh_Unwrap morf false {0.78 0.78 0.78} 1.0")

	# sys.exit()
	
	tempmesh = eval1("query sceneservice selection ? mesh")
	layerindex = eval("query layerservice layer.index ? %s" % tempmesh)
	eval("select.drop vertex")

	########################################################
	# Unwrappa meshen, efter UV-mappen
	
	for movevert in selectedverts:

		uvpos = eval("query layerservice uv.pos ? %s" % movevert)

		# out(uvpos)
		
		eval("select.type vertex")
		eval("select.element %s vertex set %s" % (layerindex, movevert))

		##########################################################
		# Kolla om aktuell vert har ett UV-vrde. Om inte = hoppa ver
		
		spork = evalN("query layerservice vert.vmapValue ? %s" % movevert)

		if len(spork) > 0:
			vertx = uvpos[0]*rhmu_scale
			verty = uvpos[1]*rhmu_scale

			eval("vert.set x %s worldSpace:true" %(vertx))
			eval("vert.set y %s worldSpace:true" %(verty))
			eval("vert.set z 0.0 worldSpace:true")
	

	
	eval("select.drop polygon")
	eval("select.drop vertex")
	eval("select.drop edge")
	######################################################

	eval("tool.viewType xyz")
	
	
	########################################################
	# Stda upp, merga osv, samt vlj alla polygoner
	
	eval("!!mesh.cleanup true")
	eval("!!vert.merge auto disco:false")
	eval("select.all")


	

except:
	out('Exception "%s" on line: %d' % (sys.exc_value, sys.exc_traceback.tb_lineno))